package hu.bme.mit.inf.riflab.osgi.client;

import hu.bme.mit.inf.riflab.osgi.interfaces.IHelloWorldService;

import java.util.ArrayList;
import java.util.List;

import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.util.tracker.ServiceTrackerCustomizer;

@SuppressWarnings("rawtypes")
public class HelloworldServiceTrackerCustomizer implements
		ServiceTrackerCustomizer {

	private final BundleContext context;
	private List<IHelloWorldService> services;

	public HelloworldServiceTrackerCustomizer(BundleContext context) {
		this.context = context;
		services = new ArrayList<IHelloWorldService>();
	}

	@Override
	public Object addingService(ServiceReference reference) {
		@SuppressWarnings("unchecked")
		IHelloWorldService service = (IHelloWorldService) context.getService(reference);
		services.add(service);
		// test the service
		service.sayHello();
		return service;
	}

	@Override
	public void modifiedService(ServiceReference reference, Object service) {
	}

	@Override
	public void removedService(ServiceReference reference, Object service) {
		services.remove(service);
	}
}
